/*-----------------------------------------------------------------------------------------------
Author     : Rey Ocampo
Company    : Husky Energy
Description: A utility class for Maintenance Servicing
Test Class : TestMaintenanceServicingUtilities, TestNewHOGTriggers
History    :
            03.06.15 rbo added code for Well Site Construction
            04.24.15 rbo added WorkOrderServiceStatus for Technical Debt fix
            04.27.15 rbo Technical Debt fixes
                     deleted all unnecessary commentations
                     declared a constant NONE_ITEM and replaced '--None--' with NONE_ITEM
                     fixed repeating literal values
                     apply optimizations that generally for best practices
                     added "with sharing" for security     
            07.22.15 rbo added code for Activity Tracking
            08.17.15 rbo added code for updating Activity Status
            09.01.15 rbo removed references to rollup fields referencing Well Site Construction
            09.21.15 ssd added utility function for Skip parts and damage            
            10.14.15 rbo modifications related to SNR and Tech Debt fixes
            01.13.16 ssd Added utility fucntions to filter Maintenance and Well Servicing Work orders
                     for triggers as part of refactoring
            01.25.16 rbo remove creation of SNR
            01.27.16 ssd Made modifications to move Skip Parts Damage logic away from SNR
            17-Oct-18 mp Added code for seting WO's User_Status_Code__c and callout to SAP when Status is updated on WO
            13.12.18 mb W-001317 changes to after WO update behaviour
            20.03.19 mb W-001359 fix so that 8FC is not reverted back to 6FCA on sap side when work order is updated there (and not tecoed)
            25.03.2020 mb Adding new parent to FEL
-------------------------------------------------------------------------------------------------*/
public with sharing class MaintenanceServicingUtilities
{

    // Work Order Service Status container class
    public class WorkOrderServiceStatus
    {
        public final String AWAITING_ON_VENDORS = 'Awaiting On Vendor(s)';
        public final String VENDORS_COMPLETE = 'Vendor(s) Complete';
        public final String FULL_COMPLETE = 'Complete';
        public final String WORKORDER_USERSTATUS_COMPLETE = '6FCA';
        public final String WORKORDER_USERSTATUS_INPROGRESS= '5X';
        public final String WORKORDER_USERSTATUS_CONFIRMED = '8FC';
    }

    private static WorkOrderServiceStatus workOrderServiceStatus = new WorkOrderServiceStatus();

    // hard coded maintenance category code, must exist in HOG_Service_Category__c
    // this will heave to be taken out during the refactoring, using a single work order object
    //private final static String SERVICECATEGORY = 'MNT';

    /***********************************************************************************************
     * Utility used to execute the Trigger code, value defaults to true
     ***********************************************************************************************/
    public static Boolean executeTriggerCode = true;

    // HOG Settings
    public static HOG_Settings__c settingsHOG = HOG_Settings__c.getInstance();

    //Hardcoded Recordtype Developer Names for Maintenance Work Orders
    public final static List<String> MAINTENANCEWORKORDER_RECORDTYPES =
            new List<String>{'Maintenance_Servicing', 'Well_Site_Construction'};

    /***********************************************************************************************************
     * Validates if work order can be ALT Confirmed and returns the message if it cannot, otherwise returns null
     ***********************************************************************************************************/
    public static String readALTConfirmedMessage(final HOG_Maintenance_Servicing_Form__c record)
    {
        String returnMessage = '';

        if (record.ALT_Confirmed__c)
        {
            returnMessage = 'Already been "ALT Confirm".';
        }
        else
        {
            if (String.isBlank(record.Work_Order_Number__c))
            {
                returnMessage = 'You need a work order number to "ALT Confirm".';
            }
            else
            {
                if (record.Maintenance_Servicing_Vendors_Count__c > 0
                        || record.VTT_Activities_Count__c > 0)
                {
                    if (IsActivityStatusInComplete(record))
                    {
                        returnMessage = 'Vendor(s) must set Activity Status to "Complete" to "ALT Confirm".';
                    }
                }
                else
                {
                    returnMessage = 'You must have at least one Vendor to "ALT Confirm".';
                }
            }
        }

        return returnMessage;
    }

    /**********************************************************************************************************
     * Utility function that verifies the incompleteness of the work order
     * This can be used to set the status of the Maintenance Work Order to
     *          'Awaiting On Vendor(s)' or 'Vendor(s) Complete'
     * Returns: true if any of the activities in Log Work Order, Well Site Construction,
     *          or Vendor Activity Tracking is incomplete, otherwise returns false
     **********************************************************************************************************/
    public static Boolean IsActivityStatusInComplete(final HOG_Maintenance_Servicing_Form__c record)
    {
        // convert null values to 0s
        Integer incompleteActivityStatusCount =
                record.Incomplete_Activity_Status_Count__c == null ? 0 : (Integer)record.Incomplete_Activity_Status_Count__c;
        Integer vttActivitiesNewCount =
                record.VTT_Activities_New_Count__c == null ? 0 : (Integer)record.VTT_Activities_New_Count__c;
        Integer vttActivitiesCompletedCount =
                record.VTT_Activities_Completed_Count__c == null ? 0 : (Integer)record.VTT_Activities_Completed_Count__c;
        Integer vttActivitiesCount =
                record.VTT_Activities_Count__c == null ? 0 : (Integer)record.VTT_Activities_Count__c;
        Integer maintenanceServicingVendorsCount =
                record.Maintenance_Servicing_Vendors_Count__c == null ? 0 : (Integer)record.Maintenance_Servicing_Vendors_Count__c;

        return (incompleteActivityStatusCount > 0
                || (vttActivitiesNewCount <= 0 ?
                vttActivitiesCount - vttActivitiesCompletedCount > 0 :
                maintenanceServicingVendorsCount <= 0
                        || (vttActivitiesNewCount <> vttActivitiesCount)));

    }

    /**********************************************************************************************************
     * Utility function to verify the configuration of whether to show parts and damages
     * as configured by the SYS Admin on Hod Order Work Type.
     * Returns: The value of the HOG_Work_Order_Type__c.Skip_Parts_Damage_Cause__c field
     * as related to the Maintenance Work Order
     **********************************************************************************************************/
    public static Boolean SkipPartsDamageCauseSysAdmin(final HOG_Maintenance_Servicing_Form__c record) {
        List<HOG_Work_Order_Type__c> workOrderTypes;
        try {
            workOrderTypes = [Select Id, Name, Skip_Parts_Damage_Cause__c
            From HOG_Work_Order_Type__c
            Where HOG_Service_Code_MAT__r.MAT_Code__c =: record.MAT_Code__c
            And HOG_Notification_Type__r.Order_Type__c =: record.Order_Type__c
            Limit 1];
            if(workOrderTypes != null && !workOrderTypes.isEmpty())
                return workOrderTypes[0].Skip_Parts_Damage_Cause__c;
        } catch (QueryException ex) {
            ApexPages.addmessage(new ApexPages.message(ApexPages.Severity.Error,
                    'Your organization\'s sharing has not been setup correctly, please contact your organization\'s Administrator'));
        }

        return false;
    }

    /**********************************************************************************************************
    * Utility function to verify whether the parts/Damage/cause section can be shown fiven
    * a Maintenance work order record.
    ***********************************************************************************************************/
    public static Boolean SkipPartsDamageCause(final HOG_Maintenance_Servicing_Form__c record) {
        return record.Equipment__r.Catalogue_Code__c == null;
    }

    /**********************************************************************************************************
     * Code manager of "before delete" trigger of HOG_Maintenance_Servicing_Form
     **********************************************************************************************************/
    public static void TriggerBeforeDeleteWorkOrder(final List<HOG_Maintenance_Servicing_Form__c> oldRecords)
    {
        for (HOG_Maintenance_Servicing_Form__c maintenanceServicingForm : oldRecords)
        {
            maintenanceServicingForm.addError('You can not delete a work order record.');
        }
    }


    /**********************************************************************************************************
     * Code manager of "before update" trigger of HOG_Maintenance_Servicing_Form
     **********************************************************************************************************/
    public static void TriggerBeforeUpdateWorkOrder(final List<HOG_Maintenance_Servicing_Form__c> newRecords,
            final Map<Id, HOG_Maintenance_Servicing_Form__c> oldMap)
    {
        final List<HOG_Maintenance_Servicing_Form__c> modifiedNotificationRecords = new List<HOG_Maintenance_Servicing_Form__c>();

        for (HOG_Maintenance_Servicing_Form__c maintenanceServicingForm : newRecords)
        {
            final HOG_Maintenance_Servicing_Form__c oldmaintenanceServicingForm = oldMap.get(maintenanceServicingForm.Id);

            if (oldmaintenanceServicingForm.ALT_Confirmed__c != maintenanceServicingForm.ALT_Confirmed__c)
            {
                maintenanceServicingForm.addError('You can not do "ALT Confirm" from this page, '
                        + 'please use the "ALT Confirm" button located at "Maintenance Work Order Detail" page.');
            }

            if (maintenanceServicingForm.Request_ALT_Confirmed__c)
            {
                if  (!oldmaintenanceServicingForm.Request_ALT_Confirmed__c)
                {
                    if (String.isBlank(maintenanceServicingForm.Work_Order_Number__c))
                    {
                        maintenanceServicingForm.addError('You need a work order number to "ALT Confirm".');
                    }
                    else
                    {
                        if (maintenanceServicingForm.Maintenance_Servicing_Vendors_Count__c > 0
                                || maintenanceServicingForm.VTT_Activities_Count__c > 0)
                        {
                            if (IsActivityStatusInComplete(maintenanceServicingForm))
                            {
                                maintenanceServicingForm.addError('Vendor(s) must set Activity Status to "Complete" to "ALT Confirm".');
                            }
                            else
                            {
                                maintenanceServicingForm.Request_ALT_Confirmed_Date__c = System.now();
                            }
                        }
                        else
                        {
                            maintenanceServicingForm.addError('You must have at least one Vendor to "ALT Confirm".');
                        }
                    }
                }
            }
            else
            {
                if  (oldmaintenanceServicingForm.Request_ALT_Confirmed__c)
                {
                    if (maintenanceServicingForm.ALT_Confirmed__c)
                    {
                        maintenanceServicingForm.Request_ALT_Confirmed__c = true; // cannot request already "ALT Confirm"
                    }
                    else
                    {
                        maintenanceServicingForm.Request_ALT_Confirmed_Date__c = null;
                    }
                }
            }

            if (!maintenanceServicingForm.TECO__c && oldmaintenanceServicingForm.TECO__c)
            {
                maintenanceServicingForm.TECO_Date_Completed__c = null;
            }

            if (maintenanceServicingForm.DLFL__c)
            {
                maintenanceServicingForm.Service_Status__c = 'Cancelled';
                maintenanceServicingForm.ALT_Confirmed__c = false;
                maintenanceServicingForm.ALT_Confirmed_Date_Completed__c = null;
            }
            else
            {
                if (maintenanceServicingForm.TECO__c || maintenanceServicingForm.CLSD__c)
                {
                    maintenanceServicingForm.Service_Status__c = workOrderServiceStatus.FULL_COMPLETE;
                }
                else
                {
                    if (maintenanceServicingForm.Maintenance_Servicing_Vendors_Count__c > 0
                            || maintenanceServicingForm.VTT_Activities_Count__c > 0)
                    {
                        Boolean isIncomplete = IsActivityStatusInComplete(maintenanceServicingForm);
                        String newWorkOrderUserStatus = maintenanceServicingForm.User_Status_Code__c;

                        if(isIncomplete){
                            // W-001359 fix
                            maintenanceServicingForm.Service_Status__c = workOrderServiceStatus.AWAITING_ON_VENDORS;

                            // Fix for W-001317 since activities can be completed from SAP side, this makes sure
                            // That when that happens we also change status on WO to 5X.. but only in case
                            // when some activity is no longer in status New
                            Integer vttActivitiesNewCount =
                                    maintenanceServicingForm.VTT_Activities_New_Count__c == null ?
                                            0 : (Integer)maintenanceServicingForm.VTT_Activities_New_Count__c;
                            Integer vttActivitiesCount =
                                    maintenanceServicingForm.VTT_Activities_Count__c == null ?
                                            0 : (Integer)maintenanceServicingForm.VTT_Activities_Count__c;

                            if(vttActivitiesNewCount != vttActivitiesCount){
                                newWorkOrderUserStatus = workOrderServiceStatus.WORKORDER_USERSTATUS_INPROGRESS;
                            }

                        } else {
                            // W-001359 fix so that 8FC is not reverted back to 6FCA on sap side when work order is
                            // updated there (and not tecoed)
                            // If a work order is completed - all activities are done
                            // Then if we get update from SAP - do not change the status
                            if(!maintenanceServicingForm.ALT_Confirmed__c &&
                                    maintenanceServicingForm.User_Status_Code__c != workOrderServiceStatus.WORKORDER_USERSTATUS_CONFIRMED){

                                maintenanceServicingForm.Service_Status__c = workOrderServiceStatus.VENDORS_COMPLETE;
                                newWorkOrderUserStatus = workOrderServiceStatus.WORKORDER_USERSTATUS_COMPLETE;
                            }
                        }
                        // In case there are some issue with WO statuses that have something to do with 5X
                        // uncomment this...
                        //newWorkOrderUserStatus = isIncomplete ? workOrderServiceStatus.WORKORDER_USERSTATUS_INPROGRESS : workOrderServiceStatus.WORKORDER_USERSTATUS_COMPLETE;

                        if(newWorkOrderUserStatus <> maintenanceServicingForm.User_Status_Code__c) {
                            maintenanceServicingForm.User_Status_Code__c = newWorkOrderUserStatus;
                            if(!Test.isRunningTest()) {
                                system.debug('VTT_IntegrationUtilities.SAP_UpdateWorkOrderStatus ' + newWorkOrderUserStatus);
                                VTT_IntegrationUtilities.SAP_UpdateWorkOrderStatus(maintenanceServicingForm.ID, newWorkOrderUserStatus);
                            }
                        }
                    }
                    else
                    {
                        maintenanceServicingForm.Service_Status__c = workOrderServiceStatus.AWAITING_ON_VENDORS;
                        maintenanceServicingForm.User_Status_Code__c = workOrderServiceStatus.WORKORDER_USERSTATUS_INPROGRESS;
                    }
                }
            }

            if (maintenanceServicingForm.Functional_Location_Description_SAP__c !=
                    oldmaintenanceServicingForm.Functional_Location_Description_SAP__c)
                maintenanceServicingForm.Name = maintenanceServicingForm.Functional_Location_Description_SAP__c == null
                        ? maintenanceServicingForm.Work_Order_Number__c
                        : maintenanceServicingForm.Functional_Location_Description_SAP__c
                                + ' - ' + maintenanceServicingForm.Work_Order_Number__c;

            if (maintenanceServicingForm.Notification_Type__c != oldmaintenanceServicingForm.Notification_Type__c
                    || maintenanceServicingForm.Work_Order_Number__c != oldmaintenanceServicingForm.Work_Order_Number__c
                    || maintenanceServicingForm.Notification_Number__c != oldmaintenanceServicingForm.Notification_Number__c
                    || maintenanceServicingForm.Order_Type__c != oldmaintenanceServicingForm.Order_Type__c
                    || maintenanceServicingForm.Functional_Location__c != oldmaintenanceServicingForm.Functional_Location__c
                    || maintenanceServicingForm.Code_Group__c != oldmaintenanceServicingForm.Code_Group__c
                    || maintenanceServicingForm.MAT_Code__c != oldmaintenanceServicingForm.MAT_Code__c
                    || maintenanceServicingForm.Numbered_User_Status__c != oldmaintenanceServicingForm.Numbered_User_Status__c
                    || maintenanceServicingForm.Notification_Priority_Number__c != oldmaintenanceServicingForm.Notification_Priority_Number__c
                    || maintenanceServicingForm.Work_Order_Priority_Number__c != oldmaintenanceServicingForm.Work_Order_Priority_Number__c
                    || maintenanceServicingForm.Equipment__c != oldmaintenanceServicingForm.Equipment__c
                    || maintenanceServicingForm.Facility__c != oldmaintenanceServicingForm.Facility__c
                    || maintenanceServicingForm.Location__c != oldmaintenanceServicingForm.Location__c
                    || maintenanceServicingForm.Well_Event__c != oldmaintenanceServicingForm.Well_Event__c
                    || maintenanceServicingForm.Functional_Location_Category_SAP__c != oldmaintenanceServicingForm.Functional_Location_Category_SAP__c
                    || maintenanceServicingForm.Business_Unit_Lookup__c != oldmaintenanceServicingForm.Business_Unit_Lookup__c
                    || maintenanceServicingForm.Operating_Field_AMU_Lookup__c != oldmaintenanceServicingForm.Operating_Field_AMU_Lookup__c
                    || maintenanceServicingForm.Operating_District_Lookup__c != oldmaintenanceServicingForm.Operating_District_Lookup__c
                    || maintenanceServicingForm.Functional_Location__c != oldmaintenanceServicingForm.Functional_Location__c)
                modifiedNotificationRecords.add(maintenanceServicingForm);
        }

        if (!modifiedNotificationRecords.isEmpty()) UpdateMaintenanceServicingForm(modifiedNotificationRecords, oldMap, false);
    }

    /**********************************************************************************************************************
     * Code manager of "after update" trigger of HOG_Maintenance_Servicing_Form
     **********************************************************************************************************************/
    public static void TriggerAfterUpdateWorkOrder(final List<HOG_Maintenance_Servicing_Form__c> newRecords,
            final Map<Id, HOG_Maintenance_Servicing_Form__c> oldMap)
    {
        UpdateMaintenanceActivityStatus(newRecords);
    }


    /*****************************************************************************************************************
     * Code manager of "before insert" trigger of HOG_Maintenance_Servicing_Form
     *****************************************************************************************************************/
    public static void TriggerBeforeInsertWorkOrder(final List<HOG_Maintenance_Servicing_Form__c> newRecords)
    {
        UpdateMaintenanceServicingForm(newRecords, new Map<Id, HOG_Maintenance_Servicing_Form__c>(), true);
    }

    /****************************************************************************************************************
     * Code manager of "after insert" trigger of HOG_Maintenance_Servicing_Form
     ****************************************************************************************************************/
    public static void TriggerAfterInsertWorkOrder(final List<HOG_Maintenance_Servicing_Form__c> newRecords)
    {
        final Map<String, Id> notificationOrderMap = new Map<String, Id>();

        for (HOG_Maintenance_Servicing_Form__c maintenanceServicingForm : newRecords)
        {
            if (!String.isBlank(maintenanceServicingForm.Notification_Number__c))
                notificationOrderMap.put(maintenanceServicingForm.Notification_Number__c, maintenanceServicingForm.Id);
        }

        if (!notificationOrderMap.isEmpty())
        {
            final Set<String> notificationOrders = notificationOrderMap.keySet();

            final List<HOG_Maintenance_Servicing_Notification__c> maintenanceNotificationOrders =
            [Select
                    Id,
                    Maintenance_Servicing_Form__c,
                    Notification_Number__c
            From HOG_Maintenance_Servicing_Notification__c
            Where Notification_Number__c In :notificationOrders];

            if (!maintenanceNotificationOrders.isEmpty())  // update maintenance notification orders
            {
                for (HOG_Maintenance_Servicing_Notification__c maintenanceNotificationOrder : maintenanceNotificationOrders)
                {
                    maintenanceNotificationOrder.Maintenance_Servicing_Form__c = notificationOrderMap.get(maintenanceNotificationOrder.Notification_Number__c);
                }

                final Savepoint savePoint = Database.setSavepoint();

                try
                {
                    update maintenanceNotificationOrders;
                }
                catch(DmlException e)
                {
                    Database.rollback(savePoint);

                    for (HOG_Maintenance_Servicing_Form__c maintenanceServicingForm : newRecords)
                        maintenanceServicingForm.addError('An unexpected error has occurred: ' + e.getMessage());
                }
            }
        }
    }

    /*******************************************************
    * Utility function to filter out Maintenance Work Orders
    * from a list of Work Order Objects
    ********************************************************/
    public static List<HOG_Maintenance_Servicing_Form__c> GetMaintenanceWorkOrders(
            List<HOG_Maintenance_Servicing_Form__c> workOrders) {

        //Get Maintenance RecordTypes
        List<RecordType> maintenanceRecordTypes = [Select Id, Name, DeveloperName
        From RecordType
        Where SobjectType='HOG_Maintenance_Servicing_Form__c'
        And DeveloperName In :MAINTENANCEWORKORDER_RECORDTYPES];

        List<HOG_Maintenance_Servicing_Form__c> maintenanceWorkOrders =
                new List<HOG_Maintenance_Servicing_Form__c>();
        for(RecordType recordType : maintenanceRecordTypes) {
            for(HOG_Maintenance_Servicing_Form__c workOrder : workOrders) {
                System.debug('workOrder.RecordTypeId: ' + workOrder.RecordTypeId +
                        ' recordType.Id: ' + recordType.Id);
                if(workOrder.RecordTypeId == recordType.Id) {
                    maintenanceWorkOrders.add(workOrder);
                }
            }
        }

        return maintenanceWorkOrders;
    }

    /**********************************************************
    * Utility function to filter out Well Servicing Work Orders
    * from a list of Work Order Objects
    ***********************************************************/
    public static List<HOG_Maintenance_Servicing_Form__c> GetWellServicingWorkOrders(
            List<HOG_Maintenance_Servicing_Form__c> workOrders) {

        //Get Maintenance RecordTypes
        List<RecordType> maintenanceRecordTypes = [Select Id, Name, DeveloperName
        From RecordType
        Where SobjectType='HOG_Maintenance_Servicing_Form__c'
        And DeveloperName In :MAINTENANCEWORKORDER_RECORDTYPES];

        List<HOG_Maintenance_Servicing_Form__c> wellServicingWorkOrders =
                new List<HOG_Maintenance_Servicing_Form__c>();
        Boolean isWellServicingWorkOrder = true;
        for(HOG_Maintenance_Servicing_Form__c workOrder : workOrders) {
            isWellServicingWorkOrder = true;
            for(RecordType recordType : maintenanceRecordTypes) {
                if(workOrder.RecordTypeId == recordType.Id) {
                    isWellServicingWorkOrder = false;
                }
            }

            //If it didn't match the Maintenance Record Types
            if(isWellServicingWorkOrder)
                wellServicingWorkOrders.add(workOrder);
        }

        return wellServicingWorkOrders;
    }

    public static void SetCorrectFLOCoNWorkOrder(List<HOG_Maintenance_Servicing_Form__c> newRecords) {
        //For bulkified querries
        final Set<String> locationFLOCnumbers = new Set<String>();
        final Set<String> facilityFLOCnumbers = new Set<String>();
        final Set<String> wellEventFLOCnumbers = new Set<String>();
        final Set<String> systemFLOCnumbers = new Set<String>();
        final Set<String> subSystemFLOCnumbers = new Set<String>();
        final Set<String> felFLOCnumbers = new Set<String>();
        final Set<String> yardFLOCnumbers = new Set<String>();
        final Set<String> categoryOneFLOCnumbers = new Set<String>();
        final Set<String> allFLOCnumbersWithoutCategory = new Set<String>();
        final Set<Id> equipmentIds = new Set<Id>();

        final Map<String,Decimal> functionalLocCategoryStringMap = VTT_Utilities.GetFunctionalLocationMap(newRecords);

        for (HOG_Maintenance_Servicing_Form__c maintenanceServicingForm : newRecords) {
            if (!String.isBlank(maintenanceServicingForm.Equipment__c))
            {
                equipmentIds.add(maintenanceServicingForm.Equipment__c);
            }

            String functionalLocationKey = maintenanceServicingForm.Functional_Location__c + '-' + maintenanceServicingForm.Functional_Location_Category_SAP__c;
            if(functionalLocCategoryStringMap.containsKey(functionalLocationKey)){

                // Checks functionalLocation category
                if(functionalLocCategoryStringMap.get(functionalLocationKey) == 1){
                    // Category one FLOC AMU and Operating District
                    categoryOneFLOCnumbers.add(maintenanceServicingForm.Functional_Location__c);
                } else if(functionalLocCategoryStringMap.get(functionalLocationKey) == 3){
                    // Facility Category
                    facilityFLOCnumbers.add(maintenanceServicingForm.Functional_Location__c);
                } else if (functionalLocCategoryStringMap.get(functionalLocationKey) == 9){
                    // Well Event Category
                    wellEventFLOCnumbers.add(maintenanceServicingForm.Functional_Location__c);
                } else if (functionalLocCategoryStringMap.get(functionalLocationKey) == 5) {
                    // System Category
                    systemFLOCnumbers.add(maintenanceServicingForm.Functional_Location__c);
                } else if (functionalLocCategoryStringMap.get(functionalLocationKey) == 6) {
                    // Sub-System Category
                    subSystemFLOCnumbers.add(maintenanceServicingForm.Functional_Location__c);
                } else if (functionalLocCategoryStringMap.get(functionalLocationKey) == 7) {
                    // FEL Category
                    felFLOCnumbers.add(maintenanceServicingForm.Functional_Location__c);
                } else if (functionalLocCategoryStringMap.get(functionalLocationKey) == 8) {
                    // Yard Category
                    yardFLOCnumbers.add(maintenanceServicingForm.Functional_Location__c);
                } else {

                    if (functionalLocCategoryStringMap.get(functionalLocationKey) != null){
                        // Anything else will be location
                        locationFLOCnumbers.add(maintenanceServicingForm.Functional_Location__c);
                    } else {
                        // This is for case when we dont have Functional_Location_Category_SAP__c populated because
                        // functionalLocCategoryStringMap would contain this key-value pair ie: H1-000-null:null
                        // So we will store those in this set
                        allFLOCnumbersWithoutCategory.add(maintenanceServicingForm.Functional_Location__c);
                    }
                }
            }
        }
        final Map<String, Business_Unit__c> businessUnitRecordMap = VTT_Utilities.getBusinessUnitRecordMap(categoryOneFLOCnumbers);
        final Map<String, Operating_District__c> operatingDistrictRecordMap = VTT_Utilities.getOperatingDistrictRecordMap(categoryOneFLOCnumbers);
        final Map<String, Field__c> operatingFieldRecordMap = VTT_Utilities.getOperatingFieldAMURecordMap(categoryOneFLOCnumbers);

        final Map<String, Location__c> locationRecordMap = VTT_Utilities.getLocationRecordMap(locationFLOCnumbers);
        final Map<String, Facility__c> facilityRecordMap = VTT_Utilities.getFacilityRecordMap(facilityFLOCnumbers);
        final Map<String, Well_Event__c> wellEventRecordMap = VTT_Utilities.getWellEventRecordMap(wellEventFLOCnumbers);
        final Map<String, System__c> systemRecordMap = VTT_Utilities.getSystemRecordMap(systemFLOCnumbers);
        final Map<String, Sub_System__c> subSystemRecordMap = VTT_Utilities.getSubSystemRecordMap(subSystemFLOCnumbers);
        final Map<String, Functional_Equipment_Level__c> felRecordMap = VTT_Utilities.getFelMap(felFLOCnumbers);
        final Map<String, Yard__c> yardRecordMap = VTT_Utilities.getYardMap(yardFLOCnumbers);
        final Map<String, Equipment__c> equipmentRecordMap = VTT_Utilities.getEquipmentRecordMap(equipmentIds);

        for (HOG_Maintenance_Servicing_Form__c maintenanceServicingForm : newRecords) {

            //This sets correct FLOC on work order based on Functional location and its category
            if (maintenanceServicingForm.Functional_Location_Category_SAP__c != null) {
                maintenanceServicingForm = putWorkOrderOnCorrectFLOC(
                        maintenanceServicingForm,
                        businessUnitRecordMap,
                        operatingDistrictRecordMap,
                        operatingFieldRecordMap,
                        locationRecordMap,
                        facilityRecordMap,
                        wellEventRecordMap,
                        systemRecordMap,
                        subSystemRecordMap,
                        felRecordMap,
                        yardRecordMap,
                        equipmentRecordMap,
                        functionalLocCategoryStringMap);
            }
        }

    }

    /***********************************************************************************************************************
     * Updates Maintenance Servicing Form and Service Notification Request Form
     ***********************************************************************************************************************/
    /* rbo 01.25.16 UpdateMaintenanceServicingForm that does not create SNR */
    /* mbrimus 01.03.17 Added logic to accomodate well event relationship */
    /* mbrimus 15.08.17 Added logic to accomodate System and SubSystem relationships */
    /* mbrimus 28.08.17 Added logic to accomodate Fel and Yard relationships */
    private static void UpdateMaintenanceServicingForm
            (
                    final List<HOG_Maintenance_Servicing_Form__c> newRecords,
                    final Map<Id, HOG_Maintenance_Servicing_Form__c> oldRecords,
                    final Boolean isInsert
            )
    {
        //For bulkified querries
        final Set<String> notificationNumbers = new Set<String>();
        final Set<String> locationFLOCnumbers = new Set<String>();
        final Set<String> facilityFLOCnumbers  = new Set<String>();
        final Set<String> wellEventFLOCnumbers  = new Set<String>();
        final Set<String> systemFLOCnumbers  = new Set<String>();
        final Set<String> subSystemFLOCnumbers  = new Set<String>();
        final Set<String> felFLOCnumbers  = new Set<String>();
        final Set<String> yardFLOCnumbers  = new Set<String>();
        final Set<String> categoryOneFLOCnumbers = new Set<String>();
        final Set<String> allFLOCnumbersWithoutCategory = new Set<String>();
        final Set<Id> equipmentIds = new Set<Id>();


        final Map<String, Id> notificationOrderMap = new Map<String, Id>();

        final Map<String, Id> hogNotificationTypeMap = GetHogNotificationTypeMap();

        final Map<String,Decimal> functionalLocCategoryStringMap = VTT_Utilities.GetFunctionalLocationMap(newRecords);

        //Loop trough records and populate Sets for queries
        for (HOG_Maintenance_Servicing_Form__c maintenanceServicingForm : newRecords)
        {
            //Assign Hog Notification Type based on Order_type__c and Notification_Type__c
            //EmailDebug('maintenanceServicingForm.Notification_Type__c: ' + maintenanceServicingForm.Notification_Type__c + ' maintenanceServicingForm.Order_Type__c: ' + maintenanceServicingForm.Order_Type__c, 'dhonds');
            maintenanceServicingForm.HOG_Notification_Type__c = hogNotificationTypeMap.get(
                    maintenanceServicingForm.Notification_Type__c +
                            maintenanceServicingForm.Order_Type__c);

            if (isInsert)
            {
                if (!String.isBlank(maintenanceServicingForm.Notification_Number__c))
                {
                    notificationNumbers.add(maintenanceServicingForm.Notification_Number__c);
                    notificationOrderMap.put(maintenanceServicingForm.Notification_Number__c, null);
                }
            }
            else
            {
                if (!String.isBlank(maintenanceServicingForm.HOG_Service_Request_Notification_Form__c))
                {
                    notificationNumbers.add(maintenanceServicingForm.HOG_Service_Request_Notification_Form__c);
                }

                // to update HOG_Maintenance_Servicing_Notification__c
                if (oldRecords.containskey(maintenanceServicingForm.Id))
                {
                    final HOG_Maintenance_Servicing_Form__c oldmaintenanceServicingForm = oldRecords.get(maintenanceServicingForm.Id);
                    if (maintenanceServicingForm.Notification_Number__c != oldmaintenanceServicingForm.Notification_Number__c)
                    {
                        notificationOrderMap.put(maintenanceServicingForm.Notification_Number__c, maintenanceServicingForm.Id);
                        notificationOrderMap.put(oldmaintenanceServicingForm.Notification_Number__c, null);
                    }
                }
            }

            // Populating FLOC sets for queries, if its a case where WO is on Equipment, then we will take data from there
            // If Equipment is null we will decide what Set to populated based on combination of Functional Location and 
            // Functional category value from WO which we check with functionalLocCategoryStringMap that we populated before
            if (!String.isBlank(maintenanceServicingForm.Equipment__c))
            {
                equipmentIds.add(maintenanceServicingForm.Equipment__c);
            }

            String functionalLocationKey = maintenanceServicingForm.Functional_Location__c + '-' + maintenanceServicingForm.Functional_Location_Category_SAP__c;
            if(functionalLocCategoryStringMap.containsKey(functionalLocationKey)){

                // Checks functionalLocation category
                if(functionalLocCategoryStringMap.get(functionalLocationKey) == 1){
                    // Category one FLOC AMU and Operating District
                    categoryOneFLOCnumbers.add(maintenanceServicingForm.Functional_Location__c);
                } else if(functionalLocCategoryStringMap.get(functionalLocationKey) == 3){
                    // Facility Category
                    facilityFLOCnumbers.add(maintenanceServicingForm.Functional_Location__c);
                } else if (functionalLocCategoryStringMap.get(functionalLocationKey) == 9){
                    // Well Event Category
                    wellEventFLOCnumbers.add(maintenanceServicingForm.Functional_Location__c);
                } else if (functionalLocCategoryStringMap.get(functionalLocationKey) == 5) {
                    // System Category
                    systemFLOCnumbers.add(maintenanceServicingForm.Functional_Location__c);
                } else if (functionalLocCategoryStringMap.get(functionalLocationKey) == 6) {
                    // Sub-System Category
                    subSystemFLOCnumbers.add(maintenanceServicingForm.Functional_Location__c);
                } else if (functionalLocCategoryStringMap.get(functionalLocationKey) == 7) {
                    // FEL Category
                    felFLOCnumbers.add(maintenanceServicingForm.Functional_Location__c);
                } else if (functionalLocCategoryStringMap.get(functionalLocationKey) == 8) {
                    // Yard Category
                    yardFLOCnumbers.add(maintenanceServicingForm.Functional_Location__c);
                } else {

                    if (functionalLocCategoryStringMap.get(functionalLocationKey) != null){
                        // Anything else will be location
                        locationFLOCnumbers.add(maintenanceServicingForm.Functional_Location__c);
                    } else {
                        // This is for case when we dont have Functional_Location_Category_SAP__c populated because
                        // functionalLocCategoryStringMap would contain this key-value pair ie: H1-000-null:null
                        // So we will store those in this set
                        allFLOCnumbersWithoutCategory.add(maintenanceServicingForm.Functional_Location__c);
                    }
                }
            }
        }

        // Section to populate FLOC object with FunctionLocation as a Key except equipments
        // Populating Maps with functional location key except equipment which is based on ids
        final Map<String, Business_Unit__c> businessUnitRecordMap = VTT_Utilities.getBusinessUnitRecordMap(categoryOneFLOCnumbers);
        final Map<String, Operating_District__c> operatingDistrictRecordMap = VTT_Utilities.getOperatingDistrictRecordMap(categoryOneFLOCnumbers);
        final Map<String, Field__c> operatingFieldRecordMap = VTT_Utilities.getOperatingFieldAMURecordMap(categoryOneFLOCnumbers);

        final Map<String, Location__c> locationRecordMap = VTT_Utilities.getLocationRecordMap(locationFLOCnumbers);
        final Map<String, Facility__c> facilityRecordMap = VTT_Utilities.getFacilityRecordMap(facilityFLOCnumbers);
        final Map<String, Well_Event__c> wellEventRecordMap = VTT_Utilities.getWellEventRecordMap(wellEventFLOCnumbers);
        final Map<String, System__c> systemRecordMap = VTT_Utilities.getSystemRecordMap(systemFLOCnumbers);
        final Map<String, Sub_System__c> subSystemRecordMap = VTT_Utilities.getSubSystemRecordMap(subSystemFLOCnumbers);
        final Map<String, Functional_Equipment_Level__c> felRecordMap = VTT_Utilities.getFelMap(felFLOCnumbers);
        final Map<String, Yard__c> yardRecordMap = VTT_Utilities.getYardMap(yardFLOCnumbers);
        final Map<String, Equipment__c> equipmentRecordMap = VTT_Utilities.getEquipmentRecordMap(equipmentIds);

        // bulkify queries
        List<HOG_Service_Request_Notification_Form__c> notificationForms;

        Map<String, HOG_Service_Request_Notification_Form__c> notificationMap;

        if (isInsert)
        {
            notificationForms =
            [Select
                    Id,
                    Notification_Number__c,
                    Work_Order_Number__c
            From HOG_Service_Request_Notification_Form__c
            Where Notification_Number__c In :notificationNumbers];

            notificationMap = new Map<String, HOG_Service_Request_Notification_Form__c>();

            for (HOG_Service_Request_Notification_Form__c notificationForm : notificationForms)
                notificationMap.put(notificationForm.Notification_Number__c, notificationForm);
        }
        else
        {
            notificationForms =
            [Select
                    Id,
                    Notification_Number__c,
                    Work_Order_Number__c
            From HOG_Service_Request_Notification_Form__c
            Where Id In :notificationNumbers];

            notificationMap = new Map<String, HOG_Service_Request_Notification_Form__c>(notificationForms);
        }

        // Second loop that will set correct values for lookups based on equipment/location etc..                        
        for (HOG_Maintenance_Servicing_Form__c maintenanceServicingForm : newRecords)
        {

            //This sets correct FLOC on work order based on Functional location and its category
            if(maintenanceServicingForm.Functional_Location_Category_SAP__c != null){
                maintenanceServicingForm = putWorkOrderOnCorrectFLOC(
                        maintenanceServicingForm,
                        businessUnitRecordMap,
                        operatingDistrictRecordMap,
                        operatingFieldRecordMap,
                        locationRecordMap,
                        facilityRecordMap,
                        wellEventRecordMap,
                        systemRecordMap,
                        subSystemRecordMap,
                        felRecordMap,
                        yardRecordMap,
                        equipmentRecordMap,
                        functionalLocCategoryStringMap);
            }

            if (isInsert)
            {
                if (maintenanceServicingForm.DLFL__c)
                {
                    maintenanceServicingForm.Service_Status__c = 'Cancelled';
                }
                else
                {
                    maintenanceServicingForm.Service_Status__c = (maintenanceServicingForm.TECO__c || maintenanceServicingForm.CLSD__c)
                            ? workOrderServiceStatus.FULL_COMPLETE : workOrderServiceStatus.AWAITING_ON_VENDORS;
                }

                maintenanceServicingForm.Name =
                        maintenanceServicingForm.Functional_Location_Description_SAP__c == null
                                ? maintenanceServicingForm.Work_Order_Number__c
                                : maintenanceServicingForm.Functional_Location_Description_SAP__c
                                + ' - ' + maintenanceServicingForm.Work_Order_Number__c;

                if (notificationMap.containskey(maintenanceServicingForm.Notification_Number__c))
                {
                    final HOG_Service_Request_Notification_Form__c notificationRecord =
                            notificationMap.get(maintenanceServicingForm.Notification_Number__c);
                    notificationRecord.Work_Order_Number__c = maintenanceServicingForm.Work_Order_Number__c;
                    notificationMap.put(maintenanceServicingForm.Notification_Number__c, notificationRecord);
                    maintenanceServicingForm.HOG_Service_Request_Notification_Form__c = notificationRecord.Id;
                }
            }
            else
            {
                if (notificationMap.containskey(maintenanceServicingForm.HOG_Service_Request_Notification_Form__c))
                {
                    final HOG_Service_Request_Notification_Form__c notificationRecord =
                            notificationMap.get(maintenanceServicingForm.HOG_Service_Request_Notification_Form__c);
                    notificationRecord.Work_Order_Number__c = maintenanceServicingForm.Work_Order_Number__c;
                    notificationMap.put(maintenanceServicingForm.HOG_Service_Request_Notification_Form__c, notificationRecord);
                }
            }
        }

        // update maintenance notification orders and maintenance work orders
        if (!notificationMap.isEmpty() || !notificationOrderMap.isEmpty())
        {
            // to update HOG_Maintenance_Servicing_Notification__c
            final Map<String, HOG_Maintenance_Servicing_Notification__c> maintenanceNotificationOrders =
                    new Map<String, HOG_Maintenance_Servicing_Notification__c>();

            if (!notificationOrderMap.isEmpty())
            {
                final Set<String> notificationOrders = notificationOrderMap.keySet();

                final List<HOG_Maintenance_Servicing_Notification__c> listNotificationOrders =
                [Select
                        Id,
                        Maintenance_Servicing_Form__c,
                        Notification_Number__c,
                        Notification_Start_Date_Time__c,
                        Notification_End_Date_Time__c
                From HOG_Maintenance_Servicing_Notification__c
                Where Notification_Number__c In :notificationOrders];

                for (HOG_Maintenance_Servicing_Notification__c listNotificationOrder : listNotificationOrders)
                    maintenanceNotificationOrders.put(listNotificationOrder.Notification_Number__c, listNotificationOrder);

                for (HOG_Maintenance_Servicing_Notification__c maintenanceNotificationOrder : maintenanceNotificationOrders.values())
                    maintenanceNotificationOrder.Maintenance_Servicing_Form__c = notificationOrderMap.get(maintenanceNotificationOrder.Notification_Number__c);
            }

            ServiceRequestNotificationUtilities.executeTriggerCode = false;

            final Savepoint savePoint = Database.setSavepoint();

            try
            {
                if (!notificationMap.isEmpty()) // update existing notifications
                {
                    update notificationMap.values();
                }

                // update maintenance notification orders and maintenance work orders
                if (maintenanceNotificationOrders != null && !maintenanceNotificationOrders.isEmpty())
                {
                    HOG_Maintenance_Servicing_Notification__c recordNotificationOrder;

                    for (HOG_Maintenance_Servicing_Form__c maintenanceServicingForm : newRecords)
                    {
                        if (maintenanceNotificationOrders.containskey(maintenanceServicingForm.Notification_Number__c))
                        {
                            recordNotificationOrder =
                                    maintenanceNotificationOrders.get(maintenanceServicingForm.Notification_Number__c);
                            maintenanceServicingForm.Required_Start_Date__c =
                                    recordNotificationOrder.Notification_Start_Date_Time__c;
                            maintenanceServicingForm.Required_End_Date__c =
                                    recordNotificationOrder.Notification_End_Date_Time__c;
                        }
                    }

                    update maintenanceNotificationOrders.values();
                }
            }
            catch(DmlException e)
            {
                Database.rollback(savePoint);

                for (HOG_Maintenance_Servicing_Form__c maintenanceServicingForm : newRecords)
                    maintenanceServicingForm.addError('An unexpected error has occurred: ' + e.getMessage());
            }
        }
    }

    /**
     * Sets correct FLOC location on work order
     * @param  workOrderToUpdate  [workOrder that will be updated]
     * @param  locationRecordMap  
     * @param  facilityRecordMap  
     * @param  wellEventRecordMap 
     * @param  systemRecordMap 
     * @param  subSystemRecordMap 
     * @param  felRecordMap 
     * @param  yardRecordMap 
     * @param  equipmentRecordMap 
     * @param  functionalLocCategoryStringMap                  
     * @return  updated Work order                 
     */
    private static HOG_Maintenance_Servicing_Form__c putWorkOrderOnCorrectFLOC(
            HOG_Maintenance_Servicing_Form__c workOrderToUpdate,
            final Map<String, Business_Unit__c> businessUnitRecordMap,
            final Map<String, Operating_District__c> operatingDistrictRecordMap,
            final Map<String, Field__c> operatingFieldRecordMap,
            final Map<String, Location__c> locationRecordMap,
            final Map<String, Facility__c> facilityRecordMap,
            final Map<String, Well_Event__c> wellEventRecordMap,
            final Map<String, System__c> systemRecordMap,
            final Map<String, Sub_System__c> subSystemRecordMap,
            final Map<String, Functional_Equipment_Level__c> felRecordMap,
            final Map<String, Yard__c> yardRecordMap,
            final Map<String, Equipment__c> equipmentRecordMap,
            final Map<String,Decimal> functionalLocCategoryStringMap
    ){

        // Equipment takes precedence
        if (equipmentRecordMap.containskey(workOrderToUpdate.Equipment__c)){

            // Equipment on Location
            if (!String.isBlank(equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Location__c)) {
                workOrderToUpdate.Business_Unit_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Location__r.Operating_Field_AMU__r.Operating_District__r.Business_Unit__c;
                workOrderToUpdate.Facility__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Location__r.Facility__c;
                workOrderToUpdate.Functional_Equipment_Level__c = null;
                workOrderToUpdate.Location__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Location__c;
                workOrderToUpdate.Operating_District_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Location__r.Operating_Field_AMU__r.Operating_District__c;
                workOrderToUpdate.Operating_Field_AMU_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Location__r.Operating_Field_AMU__c;
                workOrderToUpdate.Sub_System__c = null;
                workOrderToUpdate.System__c = null;
                workOrderToUpdate.Well_Event__c = null;
                workOrderToUpdate.Yard__c = null;

                // Equipment on Facility
            } else if (!String.isBlank(equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Facility__c)) {
                workOrderToUpdate.Business_Unit_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Facility__r.Operating_Field_AMU__r.Operating_District__r.Business_Unit__c;
                workOrderToUpdate.Facility__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Facility__c;
                workOrderToUpdate.Functional_Equipment_Level__c = null;
                workOrderToUpdate.Location__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Location__c;
                workOrderToUpdate.Operating_District_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Facility__r.Operating_Field_AMU__r.Operating_District__c;
                workOrderToUpdate.Operating_Field_AMU_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Facility__r.Operating_Field_AMU__c;
                workOrderToUpdate.Sub_System__c = null;
                workOrderToUpdate.System__c = null;
                workOrderToUpdate.Well_Event__c = null;
                workOrderToUpdate.Yard__c = null;


                // Equipment on System
            } else if (!String.isBlank(equipmentRecordMap.get(workOrderToUpdate.Equipment__c).System__c)){
                workOrderToUpdate.Business_Unit_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).System__r.Operating_Field_AMU__r.Operating_District__r.Business_Unit__c;
                workOrderToUpdate.Facility__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).System__r.Facility__c;
                workOrderToUpdate.Functional_Equipment_Level__c = null;
                workOrderToUpdate.Location__c = null;
                workOrderToUpdate.Operating_District_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).System__r.Operating_Field_AMU__r.Operating_District__c;
                workOrderToUpdate.Operating_Field_AMU_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).System__r.Operating_Field_AMU__c;
                workOrderToUpdate.Sub_System__c = null;
                workOrderToUpdate.System__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).System__c;
                workOrderToUpdate.Well_Event__c = null;
                workOrderToUpdate.Yard__c = null;

                // Equipment on Sub-System
            } else if (!String.isBlank(equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Sub_System__c)){

                // Sub-System parented by Location
                if(!String.isBlank(equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Sub_System__r.Well_ID__c)){
                    workOrderToUpdate.Business_Unit_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Sub_System__r.Well_ID__r.Operating_Field_AMU__r.Operating_District__r.Business_Unit__c;
                    workOrderToUpdate.Facility__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Sub_System__r.Well_ID__r.Facility__c;
                    workOrderToUpdate.Functional_Equipment_Level__c = null;
                    workOrderToUpdate.Location__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Sub_System__r.Well_ID__c;
                    workOrderToUpdate.Operating_District_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Sub_System__r.Well_ID__r.Operating_Field_AMU__r.Operating_District__c;
                    workOrderToUpdate.Operating_Field_AMU_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Sub_System__r.Well_ID__r.Operating_Field_AMU__c;
                    workOrderToUpdate.Sub_System__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Sub_System__c;
                    workOrderToUpdate.System__c = null;
                    workOrderToUpdate.Well_Event__c = null;
                    workOrderToUpdate.Yard__c = null;

                    // Sub-System parented by Facility
                } else if (!String.isBlank(equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Sub_System__r.Facility__c)){
                    workOrderToUpdate.Business_Unit_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Sub_System__r.Facility__r.Operating_Field_AMU__r.Operating_District__r.Business_Unit__c;
                    workOrderToUpdate.Facility__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Sub_System__r.Facility__c;
                    workOrderToUpdate.Functional_Equipment_Level__c = null;
                    workOrderToUpdate.Location__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Sub_System__r.Well_ID__c;
                    workOrderToUpdate.Operating_District_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Sub_System__r.Facility__r.Operating_Field_AMU__r.Operating_District__c;
                    workOrderToUpdate.Operating_Field_AMU_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Sub_System__r.Facility__r.Operating_Field_AMU__c;
                    workOrderToUpdate.Sub_System__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Sub_System__c;
                    workOrderToUpdate.System__c = null;
                    workOrderToUpdate.Well_Event__c = null;
                    workOrderToUpdate.Yard__c = null;

                    // Sub-System parented by System
                } else if (!String.isBlank(equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Sub_System__r.System__c)){
                    workOrderToUpdate.Business_Unit_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Sub_System__r.System__r.Operating_Field_AMU__r.Operating_District__r.Business_Unit__c;
                    workOrderToUpdate.Facility__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Sub_System__r.System__r.Facility__c;
                    workOrderToUpdate.Functional_Equipment_Level__c = null;
                    workOrderToUpdate.Location__c = null;
                    workOrderToUpdate.Operating_District_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Sub_System__r.System__r.Operating_Field_AMU__r.Operating_District__c;
                    workOrderToUpdate.Operating_Field_AMU_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Sub_System__r.System__r.Operating_Field_AMU__c;
                    workOrderToUpdate.Sub_System__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Sub_System__c;
                    workOrderToUpdate.System__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Sub_System__r.System__c;
                    workOrderToUpdate.Well_Event__c = null;
                    workOrderToUpdate.Yard__c = null;
                }

                // Equipment on FEL
            } else if (!String.isBlank(equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__c)) {

                // FEL parented by System
                if(!String.isBlank(equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.System__c)){
                    workOrderToUpdate.Business_Unit_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.System__r.Operating_Field_AMU__r.Operating_District__r.Business_Unit__c;
                    workOrderToUpdate.Facility__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.System__r.Facility__c;
                    workOrderToUpdate.Functional_Equipment_Level__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__c;
                    workOrderToUpdate.Location__c = null;
                    workOrderToUpdate.Operating_District_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.System__r.Operating_Field_AMU__r.Operating_District__c;
                    workOrderToUpdate.Operating_Field_AMU_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.System__r.Operating_Field_AMU__c;
                    workOrderToUpdate.Sub_System__c = null;
                    workOrderToUpdate.System__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.System__c;
                    workOrderToUpdate.Well_Event__c = null;
                    workOrderToUpdate.Yard__c = null;

                    // FEL parented by SubSystem
                } else if (!String.isBlank(equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.Sub_System__c)){
                    workOrderToUpdate.Business_Unit_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.Sub_System__r.Operating_Field_AMU__r.Operating_District__r.Business_Unit__c;
                    workOrderToUpdate.Facility__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.Sub_System__r.Facility__c;
                    workOrderToUpdate.Functional_Equipment_Level__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__c;
                    workOrderToUpdate.Location__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.Sub_System__r.Well_ID__c;
                    workOrderToUpdate.Operating_District_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.Sub_System__r.Operating_Field_AMU__r.Operating_District__c;
                    workOrderToUpdate.Operating_Field_AMU_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.Sub_System__r.Operating_Field_AMU__c;
                    workOrderToUpdate.Sub_System__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.Sub_System__c;
                    workOrderToUpdate.System__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.Sub_System__r.System__c;
                    workOrderToUpdate.Well_Event__c = null;
                    workOrderToUpdate.Yard__c = null;

                    // FEL parented by FEL
                } else if (!String.isBlank(equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.Functional_Equipment_Level__c)){
                    workOrderToUpdate.Business_Unit_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.Operating_Field_AMU__r.Operating_District__r.Business_Unit__c;
                    workOrderToUpdate.Facility__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.Functional_Equipment_Level__r.Facility__c;
                    workOrderToUpdate.Functional_Equipment_Level__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__c;
                    workOrderToUpdate.Location__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.Functional_Equipment_Level__r.Sub_System__r.Well_ID__c;
                    workOrderToUpdate.Operating_District_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.Operating_Field_AMU__r.Operating_District__c;
                    workOrderToUpdate.Operating_Field_AMU_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.Operating_Field_AMU__c;
                    workOrderToUpdate.Sub_System__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.Functional_Equipment_Level__r.Sub_System__c;
                    workOrderToUpdate.System__c  = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.Functional_Equipment_Level__r.System__c;
                    workOrderToUpdate.Well_Event__c = null;
                    workOrderToUpdate.Yard__c = null;

                    // FEL parented by Facility
                } else if (!String.isBlank(equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.Facility__c)){
                    workOrderToUpdate.Business_Unit_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.Facility__r.Operating_Field_AMU__r.Operating_District__r.Business_Unit__c;
                    workOrderToUpdate.Facility__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.Facility__c;
                    workOrderToUpdate.Functional_Equipment_Level__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__c;
                    workOrderToUpdate.Location__c = null;
                    workOrderToUpdate.Operating_District_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.Facility__r.Operating_Field_AMU__r.Operating_District__c;
                    workOrderToUpdate.Operating_Field_AMU_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.Facility__r.Operating_Field_AMU__c;
                    workOrderToUpdate.Sub_System__c = null;
                    workOrderToUpdate.System__c  = null;
                    workOrderToUpdate.Well_Event__c = null;
                    workOrderToUpdate.Yard__c = null;

                    // FEL parented by Well ID - MBrimus 25.03.2020 - Adding new parent to FEL
                } else if (!String.isBlank(equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.Well_ID__c)){
                    workOrderToUpdate.Business_Unit_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.Well_ID__r.Operating_Field_AMU__r.Operating_District__r.Business_Unit__c;
                    workOrderToUpdate.Facility__c = null;
                    workOrderToUpdate.Functional_Equipment_Level__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__c;
                    workOrderToUpdate.Location__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.Well_ID__c;
                    workOrderToUpdate.Operating_District_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.Well_ID__r.Operating_Field_AMU__r.Operating_District__c;
                    workOrderToUpdate.Operating_Field_AMU_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Functional_Equipment_Level__r.Well_ID__r.Operating_Field_AMU__c;
                    workOrderToUpdate.Sub_System__c = null;
                    workOrderToUpdate.System__c  = null;
                    workOrderToUpdate.Well_Event__c = null;
                    workOrderToUpdate.Yard__c = null;
                }

                // Equipment on Yard
            } else if (!String.isBlank(equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Yard__c)){
                workOrderToUpdate.Business_Unit_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Yard__r.Operating_Field_AMU__r.Operating_District__r.Business_Unit__c;
                workOrderToUpdate.Facility__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Yard__r.Facility__c;
                workOrderToUpdate.Functional_Equipment_Level__c = null;
                workOrderToUpdate.Location__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Yard__r.Well_ID__c;
                workOrderToUpdate.Operating_District_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Yard__r.Operating_Field_AMU__r.Operating_District__c;
                workOrderToUpdate.Operating_Field_AMU_Lookup__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Yard__r.Operating_Field_AMU__c;
                workOrderToUpdate.Sub_System__c = null;
                workOrderToUpdate.System__c = null;
                workOrderToUpdate.Well_Event__c = null;
                workOrderToUpdate.Yard__c = equipmentRecordMap.get(workOrderToUpdate.Equipment__c).Yard__c;
            }

        }  else {

            String functionalLocationKey = workOrderToUpdate.Functional_Location__c + '-' + workOrderToUpdate.Functional_Location_Category_SAP__c;
            if(functionalLocCategoryStringMap.containsKey(functionalLocationKey)) {

                //Checks functionalLocation category
                if(functionalLocCategoryStringMap.get(functionalLocationKey) == 1
                        && (operatingDistrictRecordMap.containskey(workOrderToUpdate.Functional_Location__c)
                        || operatingFieldRecordMap.containskey(workOrderToUpdate.Functional_Location__c)
                        || businessUnitRecordMap.containskey(workOrderToUpdate.Functional_Location__c))) {

                    if(businessUnitRecordMap.containskey(workOrderToUpdate.Functional_Location__c)){

                        // BUSINESS UNIT
                        workOrderToUpdate.Business_Unit_Lookup__c = businessUnitRecordMap.get(workOrderToUpdate.Functional_Location__c).Id;
                        workOrderToUpdate.Facility__c = null;
                        workOrderToUpdate.Functional_Equipment_Level__c = null;
                        workOrderToUpdate.Location__c = null;
                        workOrderToUpdate.Operating_District_Lookup__c = null;
                        workOrderToUpdate.Operating_Field_AMU_Lookup__c = null;
                        workOrderToUpdate.Sub_System__c = null;
                        workOrderToUpdate.System__c = null;
                        workOrderToUpdate.Well_Event__c = null;
                        workOrderToUpdate.Yard__c = null;

                    } else if(operatingDistrictRecordMap.containskey(workOrderToUpdate.Functional_Location__c)){

                        // OPERATING DISCTRICT
                        workOrderToUpdate.Business_Unit_Lookup__c = operatingDistrictRecordMap.get(workOrderToUpdate.Functional_Location__c).Business_Unit__c;
                        workOrderToUpdate.Facility__c = null;
                        workOrderToUpdate.Functional_Equipment_Level__c = null;
                        workOrderToUpdate.Location__c = null;
                        workOrderToUpdate.Operating_District_Lookup__c = operatingDistrictRecordMap.get(workOrderToUpdate.Functional_Location__c).Id;
                        workOrderToUpdate.Operating_Field_AMU_Lookup__c = null;
                        workOrderToUpdate.Sub_System__c = null;
                        workOrderToUpdate.System__c = null;
                        workOrderToUpdate.Well_Event__c = null;
                        workOrderToUpdate.Yard__c = null;

                    } else if (operatingFieldRecordMap.containskey(workOrderToUpdate.Functional_Location__c)) {

                        // OPERATING FIELD AMU
                        workOrderToUpdate.Business_Unit_Lookup__c = operatingFieldRecordMap.get(workOrderToUpdate.Functional_Location__c).Operating_District__r.Business_Unit__c;
                        workOrderToUpdate.Facility__c = null;
                        workOrderToUpdate.Functional_Equipment_Level__c = null;
                        workOrderToUpdate.Location__c = null;
                        workOrderToUpdate.Operating_District_Lookup__c = operatingFieldRecordMap.get(workOrderToUpdate.Functional_Location__c).Operating_District__c;
                        workOrderToUpdate.Operating_Field_AMU_Lookup__c = operatingFieldRecordMap.get(workOrderToUpdate.Functional_Location__c).Id;
                        workOrderToUpdate.Sub_System__c = null;
                        workOrderToUpdate.System__c = null;
                        workOrderToUpdate.Well_Event__c = null;
                        workOrderToUpdate.Yard__c = null;

                    }

                } else if(functionalLocCategoryStringMap.get(functionalLocationKey) == 3
                        && facilityRecordMap.containsKey(workOrderToUpdate.Functional_Location__c)){

                    // Facility Category
                    workOrderToUpdate.Business_Unit_Lookup__c = facilityRecordMap.get(workOrderToUpdate.Functional_Location__c).Operating_Field_AMU__r.Operating_District__r.Business_Unit__c;
                    workOrderToUpdate.Facility__c = facilityRecordMap.get(workOrderToUpdate.Functional_Location__c).Id;
                    workOrderToUpdate.Functional_Equipment_Level__c = null;
                    workOrderToUpdate.Location__c = null;
                    workOrderToUpdate.Operating_District_Lookup__c = facilityRecordMap.get(workOrderToUpdate.Functional_Location__c).Operating_Field_AMU__r.Operating_District__c;
                    workOrderToUpdate.Operating_Field_AMU_Lookup__c = facilityRecordMap.get(workOrderToUpdate.Functional_Location__c).Operating_Field_AMU__c;
                    workOrderToUpdate.Sub_System__c = null;
                    workOrderToUpdate.System__c = null;
                    workOrderToUpdate.Well_Event__c = null;
                    workOrderToUpdate.Yard__c = null;

                } else if (functionalLocCategoryStringMap.get(functionalLocationKey) == 5
                        && systemRecordMap.containsKey(workOrderToUpdate.Functional_Location__c)){

                    // System Category
                    // Operating_Field_AMU__c should be correctly set even if System is on Facility
                    workOrderToUpdate.Business_Unit_Lookup__c = systemRecordMap.get(workOrderToUpdate.Functional_Location__c).Operating_Field_AMU__r.Operating_District__r.Business_Unit__c;
                    workOrderToUpdate.Facility__c = systemRecordMap.get(workOrderToUpdate.Functional_Location__c).Facility__c;
                    workOrderToUpdate.Functional_Equipment_Level__c = null;
                    workOrderToUpdate.Location__c = null;
                    workOrderToUpdate.Operating_District_Lookup__c = systemRecordMap.get(workOrderToUpdate.Functional_Location__c).Operating_Field_AMU__r.Operating_District__c;
                    workOrderToUpdate.Operating_Field_AMU_Lookup__c = systemRecordMap.get(workOrderToUpdate.Functional_Location__c).Operating_Field_AMU__c;
                    workOrderToUpdate.Sub_System__c = null;
                    workOrderToUpdate.System__c = systemRecordMap.get(workOrderToUpdate.Functional_Location__c).Id;
                    workOrderToUpdate.Well_Event__c = null;
                    workOrderToUpdate.Yard__c = null;

                } else if (functionalLocCategoryStringMap.get(functionalLocationKey) == 6
                        && subSystemRecordMap.containsKey(workOrderToUpdate.Functional_Location__c)){

                    // Sub-System Category
                    // Correct AMU will be decided based on if Sub-System is on Location or System
                    if(subSystemRecordMap.get(workOrderToUpdate.Functional_Location__c).Well_ID__c != null){

                        workOrderToUpdate.Business_Unit_Lookup__c = subSystemRecordMap.get(workOrderToUpdate.Functional_Location__c).Well_ID__r.Operating_Field_AMU__r.Operating_District__r.Business_Unit__c;
                        workOrderToUpdate.Facility__c = subSystemRecordMap.get(workOrderToUpdate.Functional_Location__c).Well_ID__r.Facility__c;
                        workOrderToUpdate.Functional_Equipment_Level__c = null;
                        workOrderToUpdate.Location__c = subSystemRecordMap.get(workOrderToUpdate.Functional_Location__c).Well_ID__c;
                        workOrderToUpdate.Operating_District_Lookup__c = subSystemRecordMap.get(workOrderToUpdate.Functional_Location__c).Well_ID__r.Operating_Field_AMU__r.Operating_District__c;
                        workOrderToUpdate.Operating_Field_AMU_Lookup__c = subSystemRecordMap.get(workOrderToUpdate.Functional_Location__c).Well_ID__r.Operating_Field_AMU__c;
                        workOrderToUpdate.Sub_System__c = subSystemRecordMap.get(workOrderToUpdate.Functional_Location__c).Id;
                        workOrderToUpdate.System__c = null;
                        workOrderToUpdate.Well_Event__c = null;
                        workOrderToUpdate.Yard__c = null;

                    } else if (subSystemRecordMap.get(workOrderToUpdate.Functional_Location__c).System__c != null){

                        workOrderToUpdate.Business_Unit_Lookup__c = subSystemRecordMap.get(workOrderToUpdate.Functional_Location__c).System__r.Operating_Field_AMU__r.Operating_District__r.Business_Unit__c;
                        workOrderToUpdate.Facility__c = subSystemRecordMap.get(workOrderToUpdate.Functional_Location__c).System__r.Facility__c;
                        workOrderToUpdate.Functional_Equipment_Level__c = null;
                        workOrderToUpdate.Location__c = null;
                        workOrderToUpdate.Operating_District_Lookup__c = subSystemRecordMap.get(workOrderToUpdate.Functional_Location__c).System__r.Operating_Field_AMU__r.Operating_District__c;
                        workOrderToUpdate.Operating_Field_AMU_Lookup__c = subSystemRecordMap.get(workOrderToUpdate.Functional_Location__c).System__r.Operating_Field_AMU__c;
                        workOrderToUpdate.Sub_System__c = subSystemRecordMap.get(workOrderToUpdate.Functional_Location__c).Id;
                        workOrderToUpdate.System__c = subSystemRecordMap.get(workOrderToUpdate.Functional_Location__c).System__c;
                        workOrderToUpdate.Well_Event__c = null;
                        workOrderToUpdate.Yard__c = null;

                    } else if (subSystemRecordMap.get(workOrderToUpdate.Functional_Location__c).Facility__c != null){

                        workOrderToUpdate.Business_Unit_Lookup__c = subSystemRecordMap.get(workOrderToUpdate.Functional_Location__c).Facility__r.Operating_Field_AMU__r.Operating_District__r.Business_Unit__c;
                        workOrderToUpdate.Facility__c = subSystemRecordMap.get(workOrderToUpdate.Functional_Location__c).Facility__c;
                        workOrderToUpdate.Functional_Equipment_Level__c = null;
                        workOrderToUpdate.Location__c = null;
                        workOrderToUpdate.Operating_District_Lookup__c = subSystemRecordMap.get(workOrderToUpdate.Functional_Location__c).Facility__r.Operating_Field_AMU__r.Operating_District__c;
                        workOrderToUpdate.Operating_Field_AMU_Lookup__c = subSystemRecordMap.get(workOrderToUpdate.Functional_Location__c).Facility__r.Operating_Field_AMU__c;
                        workOrderToUpdate.Sub_System__c = subSystemRecordMap.get(workOrderToUpdate.Functional_Location__c).Id;
                        workOrderToUpdate.System__c = subSystemRecordMap.get(workOrderToUpdate.Functional_Location__c).System__c;
                        workOrderToUpdate.Well_Event__c = null;
                        workOrderToUpdate.Yard__c = null;
                    }


                } else if (functionalLocCategoryStringMap.get(functionalLocationKey) == 7
                        && felRecordMap.containsKey(workOrderToUpdate.Functional_Location__c)){

                    // FEL parented by System
                    if(!String.isBlank(felRecordMap.get(workOrderToUpdate.Functional_Location__c).System__c)){
                        workOrderToUpdate.Business_Unit_Lookup__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).System__r.Operating_Field_AMU__r.Operating_District__r.Business_Unit__c;
                        workOrderToUpdate.Facility__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).System__r.Facility__c;
                        workOrderToUpdate.Functional_Equipment_Level__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).Id;
                        workOrderToUpdate.Location__c = null;
                        workOrderToUpdate.Operating_District_Lookup__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).System__r.Operating_Field_AMU__r.Operating_District__c;
                        workOrderToUpdate.Operating_Field_AMU_Lookup__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).System__r.Operating_Field_AMU__c;
                        workOrderToUpdate.Sub_System__c = null;
                        workOrderToUpdate.System__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).System__c;
                        workOrderToUpdate.Well_Event__c = null;
                        workOrderToUpdate.Yard__c = null;

                        // FEL parented by SubSystem
                    } else if (!String.isBlank(felRecordMap.get(workOrderToUpdate.Functional_Location__c).Sub_System__c)){
                        workOrderToUpdate.Business_Unit_Lookup__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).Sub_System__r.Operating_Field_AMU__r.Operating_District__r.Business_Unit__c;
                        workOrderToUpdate.Facility__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).Sub_System__r.Facility__c;
                        workOrderToUpdate.Functional_Equipment_Level__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).Id;
                        workOrderToUpdate.Location__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).Sub_System__r.Well_ID__c;
                        workOrderToUpdate.Operating_District_Lookup__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).Sub_System__r.Operating_Field_AMU__r.Operating_District__c;
                        workOrderToUpdate.Operating_Field_AMU_Lookup__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).Sub_System__r.Operating_Field_AMU__c;
                        workOrderToUpdate.Sub_System__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).Sub_System__c;
                        workOrderToUpdate.System__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).Sub_System__r.System__c;
                        workOrderToUpdate.Well_Event__c = null;
                        workOrderToUpdate.Yard__c = null;

                        // FEL parented by FEL
                    } else if (!String.isBlank(felRecordMap.get(workOrderToUpdate.Functional_Location__c).Functional_Equipment_Level__c)){
                        workOrderToUpdate.Business_Unit_Lookup__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).Operating_Field_AMU__r.Operating_District__r.Business_Unit__c;
                        workOrderToUpdate.Facility__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).Functional_Equipment_Level__r.Facility__c;
                        workOrderToUpdate.Functional_Equipment_Level__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).Id;
                        workOrderToUpdate.Location__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).Functional_Equipment_Level__r.Sub_System__r.Well_ID__c;
                        workOrderToUpdate.Operating_District_Lookup__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).Operating_Field_AMU__r.Operating_District__c;
                        workOrderToUpdate.Operating_Field_AMU_Lookup__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).Operating_Field_AMU__c;
                        workOrderToUpdate.Sub_System__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).Functional_Equipment_Level__r.Sub_System__c;
                        workOrderToUpdate.System__c  = felRecordMap.get(workOrderToUpdate.Functional_Location__c).Functional_Equipment_Level__r.System__c;
                        workOrderToUpdate.Well_Event__c = null;
                        workOrderToUpdate.Yard__c = null;

                        // FEL parented by Facility
                    } else if (!String.isBlank(felRecordMap.get(workOrderToUpdate.Functional_Location__c).Facility__c)){
                        workOrderToUpdate.Business_Unit_Lookup__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).Facility__r.Operating_Field_AMU__r.Operating_District__r.Business_Unit__c;
                        workOrderToUpdate.Facility__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).Facility__c;
                        workOrderToUpdate.Functional_Equipment_Level__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).Id;
                        workOrderToUpdate.Location__c = null;
                        workOrderToUpdate.Operating_District_Lookup__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).Facility__r.Operating_Field_AMU__r.Operating_District__c;
                        workOrderToUpdate.Operating_Field_AMU_Lookup__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).Facility__r.Operating_Field_AMU__c;
                        workOrderToUpdate.Sub_System__c = null;
                        workOrderToUpdate.System__c  = null;
                        workOrderToUpdate.Well_Event__c = null;
                        workOrderToUpdate.Yard__c = null;

                        // FEL parented by WellLocation - MBrimus 25.03.2020 - Adding new parent to FEL
                    } else if (!String.isBlank(felRecordMap.get(workOrderToUpdate.Functional_Location__c).Well_ID__c)){
                        workOrderToUpdate.Business_Unit_Lookup__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).Well_ID__r.Operating_Field_AMU__r.Operating_District__r.Business_Unit__c;
                        workOrderToUpdate.Facility__c = null;
                        workOrderToUpdate.Functional_Equipment_Level__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).Id;
                        workOrderToUpdate.Location__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).Well_ID__c;
                        workOrderToUpdate.Operating_District_Lookup__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).Well_ID__r.Operating_Field_AMU__r.Operating_District__c;
                        workOrderToUpdate.Operating_Field_AMU_Lookup__c = felRecordMap.get(workOrderToUpdate.Functional_Location__c).Well_ID__r.Operating_Field_AMU__c;
                        workOrderToUpdate.Sub_System__c = null;
                        workOrderToUpdate.System__c  = null;
                        workOrderToUpdate.Well_Event__c = null;
                        workOrderToUpdate.Yard__c = null;
                    }

                } else if (functionalLocCategoryStringMap.get(functionalLocationKey) == 8
                        && yardRecordMap.containsKey(workOrderToUpdate.Functional_Location__c)){

                    // YARD
                    workOrderToUpdate.Business_Unit_Lookup__c = yardRecordMap.get(workOrderToUpdate.Functional_Location__c).Operating_Field_AMU__r.Operating_District__r.Business_Unit__c;
                    workOrderToUpdate.Facility__c = yardRecordMap.get(workOrderToUpdate.Functional_Location__c).Facility__c;
                    workOrderToUpdate.Functional_Equipment_Level__c = null;
                    workOrderToUpdate.Location__c = yardRecordMap.get(workOrderToUpdate.Functional_Location__c).Well_ID__c;
                    workOrderToUpdate.Operating_District_Lookup__c = yardRecordMap.get(workOrderToUpdate.Functional_Location__c).Operating_Field_AMU__r.Operating_District__c;
                    workOrderToUpdate.Operating_Field_AMU_Lookup__c = yardRecordMap.get(workOrderToUpdate.Functional_Location__c).Operating_Field_AMU__c;
                    workOrderToUpdate.Sub_System__c = null;
                    workOrderToUpdate.System__c = null;
                    workOrderToUpdate.Well_Event__c = null;
                    workOrderToUpdate.Yard__c = yardRecordMap.get(workOrderToUpdate.Functional_Location__c).Id;

                } else if (functionalLocCategoryStringMap.get(functionalLocationKey) == 9
                        && wellEventRecordMap.containsKey(workOrderToUpdate.Functional_Location__c)){

                    //Well Event Category
                    //In case of well event we are setting also a location for WO from well event 
                    //and all other fields = like AMU Unit etc will be set from Location of this well event
                    workOrderToUpdate.Business_Unit_Lookup__c = wellEventRecordMap.get(workOrderToUpdate.Functional_Location__c).Well_ID__r.Operating_Field_AMU__r.Operating_District__r.Business_Unit__c;
                    workOrderToUpdate.Facility__c = wellEventRecordMap.get(workOrderToUpdate.Functional_Location__c).Well_ID__r.Facility__c;
                    workOrderToUpdate.Functional_Equipment_Level__c = null;
                    workOrderToUpdate.Location__c = wellEventRecordMap.get(workOrderToUpdate.Functional_Location__c).Well_ID__c;
                    workOrderToUpdate.Operating_District_Lookup__c = wellEventRecordMap.get(workOrderToUpdate.Functional_Location__c).Well_ID__r.Operating_Field_AMU__r.Operating_District__c;
                    workOrderToUpdate.Operating_Field_AMU_Lookup__c = wellEventRecordMap.get(workOrderToUpdate.Functional_Location__c).Well_ID__r.Operating_Field_AMU__c;
                    workOrderToUpdate.Sub_System__c = null;
                    workOrderToUpdate.System__c = null;
                    workOrderToUpdate.Well_Event__c = wellEventRecordMap.get(workOrderToUpdate.Functional_Location__c).Id;
                    workOrderToUpdate.Yard__c = null;

                } else {

                    // Anything else will be location
                    if(locationRecordMap.containsKey(workOrderToUpdate.Functional_Location__c)){
                        workOrderToUpdate.Business_Unit_Lookup__c = locationRecordMap.get(workOrderToUpdate.Functional_Location__c).Operating_Field_AMU__r.Operating_District__r.Business_Unit__c;
                        workOrderToUpdate.Facility__c = locationRecordMap.get(workOrderToUpdate.Functional_Location__c).Facility__c;
                        workOrderToUpdate.Functional_Equipment_Level__c = null;
                        workOrderToUpdate.Location__c = locationRecordMap.get(workOrderToUpdate.Functional_Location__c).Id;
                        workOrderToUpdate.Operating_District_Lookup__c = locationRecordMap.get(workOrderToUpdate.Functional_Location__c).Operating_Field_AMU__r.Operating_District__c;
                        workOrderToUpdate.Operating_Field_AMU_Lookup__c = locationRecordMap.get(workOrderToUpdate.Functional_Location__c).Operating_Field_AMU__c;
                        workOrderToUpdate.Sub_System__c = null;
                        workOrderToUpdate.System__c = null;
                        workOrderToUpdate.Well_Event__c = null;
                        workOrderToUpdate.Yard__c = null;
                    }
                }
            }
        }
        return workOrderToUpdate;
    }

    /***************************************************
     * Update activity status based on Work Order status
     ***************************************************/
    private static void UpdateMaintenanceActivityStatus
            (final List<HOG_Maintenance_Servicing_Form__c> workOrderList)
    {
        Set<Id> workOrderSet = new Set<Id>();
        Map<Id, HOG_Maintenance_Servicing_Form__c> workOrderMap = new Map<Id, HOG_Maintenance_Servicing_Form__c>();

        for(HOG_Maintenance_Servicing_Form__c workOrder : workOrderList)
        {
            if (workOrder.DLFL__c || workOrder.TECO__c || workOrder.CLSD__c)
            {
                workOrderMap.put(workOrder.Id, workOrder);
                workOrderSet.add(workOrder.Id);
            }
        }

        if(!workOrderMap.isEmpty())
        {
            final List<Work_Order_Activity__c> activityList =
            [
                    Select
                            Id,
                            Maintenance_Work_Order__c,
                            Status__c
                    From Work_Order_Activity__c
                    Where Maintenance_Work_Order__c In :workOrderSet
            ];

            for(Work_Order_Activity__c activity : activityList)
            {
                if (workOrderMap.containskey(activity.Maintenance_Work_Order__c))
                {
                    final HOG_Maintenance_Servicing_Form__c workOrderRecord = workOrderMap.get(activity.Maintenance_Work_Order__c);

                    if (workOrderRecord.DLFL__c)
                        activity.Status__c = VTT_Utilities.ACTIVITY_STATUS_CANCELLED;
                    else
                    {
                        if (workOrderRecord.TECO__c || workOrderRecord.CLSD__c)
                            activity.Status__c = VTT_Utilities.ACTIVITY_STATUS_COMPLETED;
                    }
                }
            }

            final Savepoint savePoint = Database.setSavepoint();

            try
            {
                VTT_Utilities.executeTriggerCode = false;
                update activityList;
            }
            catch(DmlException e)
            {
                Database.rollback(savePoint);

                for (HOG_Maintenance_Servicing_Form__c maintenanceServicingForm : workOrderList)
                    maintenanceServicingForm.addError('An unexpected error has occurred: ' + e.getMessage());
            }
        }
    }

    /**********************************************************
    * This function returns a map of HOG_Notification_Type mapped
    * by Notification_Type__c and Order_Type__c as a combined
    * string (eg. ['EMMPX1', Id of Notification type])
    **********************************************************/
    private static Map<String, Id> GetHogNotificationTypeMap() {
        //Create HOG_Notification_Type__c map
        List<HOG_Notification_Type__c> hogNotificationTypes = [Select Id, Name, Notification_Type__c, Order_Type__c
        From HOG_Notification_Type__c];
        Map<String, Id> hogNotificationTypeMap = new Map<String, Id>();

        for(HOG_Notification_Type__c notificationType : hogNotificationTypes) {
            hogNotificationTypeMap.put(
                    notificationType.Notification_Type__c +
                            notificationType.Order_Type__c,
                    notificationType.Id);
        }

        return hogNotificationTypeMap;
    }
}